indexing
	description: 
		"Die Klasse, die dem Entwurfsmuster den Namen gibt"
		"Sie ist von der Klasse Graphik abgeleitet und kann wiederum mehrere Graphiken enthalten"
		"Die Botschaften werden an die Kinder weitergeleitet"

class Kompositum

inherit 
	Graphik
		rename
			SetzeKoordinaten as SuperSetzeKoordinaten,
			ZeichneDich as SuperZeichneDich
		end
	Graphik 
		redefine
			SetzeKoordinaten,
			ZeichneDich
		select 
			SetzeKoordinaten,
			ZeichneDich		
		end

creation
	make

feature {NONE}
	make is
		do
			Name:= "Kompositum"
			Initialisiere
			!!Kinder.make
		end

	BerechneKoordinate(KAlt1,Kalt2,KNeu1,KNeu2,KAlt: REAL): REAL is
		do
			if (KAlt2 - KAlt1>0) then
				result:= (KAlt - KAlt1)* (KNeu2 - KNeu1) / (KAlt2 - KAlt1)+ KNeu1
			else
				result:= 0
			end
		end

feature {Basisgraphik}
	-- Geerbte und erweiterte Methoden der Klasse Graphik

	SetzeKoordinaten(X1, Y1, X2, Y2: REAL) is
		local
			Index: INTEGER
			KX1, KY1, KX2, KY2: REAL
		do
			Index:= Kinder.index
			from
				Kinder.start
			until
				Kinder.after
			loop
				KX1:= Kinder.item.Xlo
				KX1:= BerechneKoordinate(Xlo,Xru,X1,X2,KX1)
				KX2:= Kinder.item.Xru
				KX2:= BerechneKoordinate(Xlo,Xru,X1,X2,KX2)
				KY1:= Kinder.item.Ylo
				KY1:= BerechneKoordinate(Ylo,Yru,Y1,Y2,KY1)
				KY2:= Kinder.item.Yru
				KY2:= BerechneKoordinate(Ylo,Yru,Y1,Y2,KY2)
				Kinder.item.SetzeKoordinaten(KX1, KY1, KX2, KY2)
				Kinder.forth
			end
			SuperSetzeKoordinaten(X1, Y1, X2, Y2)
			Kinder.go_i_th (Index)
		end;

	ZeichneDich(Hervorgehoben,Markiert: BOOLEAN; dc: WEL_CLIENT_DC) is
		local
			Index: INTEGER
		do
			Index:= Kinder.index
			from
				Kinder.start
			until
				Kinder.after
			loop
				Kinder.item.zeichneDich(Hervorgehoben,false, dc)
				Kinder.forth
			end;
			SuperZeichneDich(Hervorgehoben,Markiert,dc)
			Kinder.go_i_th (Index)
		end


feature {Basisgraphik,GraphikContainer}
	Kinder: LINKED_LIST[Graphik]

	-- Zustzliche Methoden zur Klasse Graphik
	-- Hier mu sichergestellt werden, da es sich um ein Kompositum handelt

	EntferneErstesKind: Graphik is
		do
			Kinder.start
			if not(Kinder.after) then
				result:= Kinder.item
				Kinder.remove
			else
				result:= void
			end
		end

	FuegeHinzu(eineGraphik: Graphik) is
		do
			Kinder.extend(eineGraphik)
			if ((Xlo = Ungueltig)	or (Xlo > eineGraphik.Xlo)) then
				Xlo:= eineGraphik.Xlo
			end;	
			if ((Ylo = Ungueltig)	or (Ylo > eineGraphik.Ylo)) then
				Ylo:= eineGraphik.Ylo
			end;	
			if ((Xru = Ungueltig)	or (Xru < eineGraphik.Xru)) then
				Xru:= eineGraphik.Xru
			end;	
			if ((Yru = Ungueltig)	or (Yru < eineGraphik.Yru)) then
				Yru:= eineGraphik.Yru
			end	
		end

end