indexing
	description: 
		"Benutzeroberflche, bei Eingaben werden Methoden der Klasse GraphikContainer aufgerufen"

class
	MAIN_WINDOW

inherit
	WEL_FRAME_WINDOW
		redefine
			on_paint,
			on_control_command,
			on_left_button_down,
			on_mouse_move 
		end

	WEL_WINDOWS_ROUTINES
		export
			{NONE} all
		end

	WEL_STANDARD_COLORS
		export
			{NONE} all
		end

creation
	make

feature {NONE} -- Initialisierung

	make is
		local
			eineBasisGraphik: BasisGraphik
			ln: Linie
			el: Ellipse

		do
			make_top ("Kompositum-Demo")
			resize (345, 460)
			!! HervorhebenButton.make (Current, "Hervorheben",
				10, 30, 100, 35, -1)
			!! GruppierenButton.make (Current, "Gruppieren",
				10, 70, 100, 35, -1)
			!! DegruppierenButton.make (Current, "Degruppieren",
				10, 110, 100, 35, -1)
			!! EntfernenButton.make (Current, "Entfernen",
				10, 150, 100, 35, -1)
			!! NeueKoordsButton.make (Current, "Neue Koord.",
				10, 190, 100, 35, -1)
			!! NeueLinieButton.make (Current, "Neue Linie",
				115, 30, 100, 35, -1)
			!! NeueEllipseButton.make (Current, "Neue Ellipse",
				220, 30, 100, 35, -1)
			!! Liste.make (Current,
				10, 230, 100, 200, -1)

			!! dc.make (Current)
			dc.get

			!!derGraphikContainer.make(Current)

		end

	derGraphikContainer: GraphikContainer
	dc: WEL_CLIENT_DC

feature {NONE} -- Buttons

	HervorhebenButton: WEL_PUSH_BUTTON
	GruppierenButton: WEL_PUSH_BUTTON
	DegruppierenButton: WEL_PUSH_BUTTON
	EntfernenButton: WEL_PUSH_BUTTON
	NeueKoordsButton: WEL_PUSH_BUTTON
	NeueLinieButton: WEL_PUSH_BUTTON
	NeueEllipseButton: WEL_PUSH_BUTTON

feature {GraphikContainer} -- Auswahlliste

	Liste: WEL_MULTIPLE_SELECTION_LIST_BOX

feature {NONE} -- Implementation


	on_control_command (control: WEL_CONTROL) is
		-- Reaktion auf Mouse-Click auf Steuerelemente
		-- Aufruf der GraphikContainer-Methoden
		do
			if (derGraphikContainer.ErwarteClickNr = 0) then
				if control = HervorhebenButton then
					derGraphikContainer.MarkierteHervorheben;
				elseif control = GruppierenButton then
					derGraphikContainer.MarkierteGruppieren;
				elseif control = DegruppierenButton then
					derGraphikContainer.MarkierteDegruppieren;
				elseif control = EntfernenButton then
					derGraphikContainer.MarkierteEntfernen;
				elseif control = NeueKoordsButton then
					derGraphikContainer.SetzeKoordinaten(0,0);
				elseif control = NeueLinieButton then
					derGraphikContainer.NeueLinie
				elseif control = NeueEllipseButton then
					derGraphikContainer.NeueEllipse
				elseif control = Liste then
					derGraphikContainer.MarkierungenAbgleichen
				end
			end
			invalidate
		end

	on_left_button_down (keys, x_pos, y_pos: INTEGER) is
		-- Reaktion auf Mouse-Click ins Zeichenfeld
		-- Falls Koordinateneingabe erwartet wird	
		do
			if (derGraphikContainer.ErwarteClickNr > 0) then
				derGraphikContainer.SetzeKoordinaten(x_pos, y_pos)
				invalidate
			end
		end

	

	on_mouse_move (keys: INTEGER; x_pos: INTEGER; y_pos: INTEGER) is
		-- Reaktion auf Mouse-Bewegung
		-- Falls 2. Koordinateneingabe erwartet wird
		-- Neues Setzen des umfassenden Rechtecks
		local
			Rechteck: WEL_RECT
			X1,Y1,X2,Y2: INTEGER
		do
			if (derGraphikContainer.ErwarteClickNr = 2) then
				if (derGraphikContainer.Xlo > derGraphikContainer.Xru) then
					X1 := derGraphikContainer.Xru -1
					X2 := derGraphikContainer.Xlo +1
				else
					X1 := derGraphikContainer.Xlo -1
					X2 := derGraphikContainer.Xru +1
				end;
				if (derGraphikContainer.Ylo > derGraphikContainer.Yru) then
					Y1 := derGraphikContainer.Yru -1
					Y2 := derGraphikContainer.Ylo+1
				else
					Y1 := derGraphikContainer.Ylo -1
					Y2 := derGraphikContainer.Yru +1
				end;
				derGraphikContainer.SetzeRU(x_pos,y_pos)
				!!Rechteck.make(X1,Y1,X2,Y2)
				invalidate_rect(Rechteck,true)
			end
		end

	on_paint (paint_dc: WEL_PAINT_DC; invalid_rect: WEL_RECT) is
		-- Neues Zeichnen aller Graphiken
		-- bei Koordinateneingabe entsprechende Textausgebe
		-- bei 2. Koordinateneingabe Zeichnen des umfassenden Rechtecks	
		local
			pen: WEL_PEN
		do
			derGraphikContainer.AlleZeichnen(dc);
			if (derGraphikContainer.ErwarteClickNr = 1) then
				dc.text_out(10,5,"Klicke den neuen Punkt fr die linke obere Ecke!")
			end
			if (derGraphikContainer.ErwarteClickNr = 2) then
				dc.text_out(10,5,"Klicke den neuen Punkt fr die rechte untere Ecke!")
				!! pen.make (1,1,grey)
				dc.select_pen(pen)
				dc.line (derGraphikContainer.Xru,derGraphikContainer.Yru,derGraphikContainer.Xlo,derGraphikContainer.Yru)
				dc.line (derGraphikContainer.Xlo,derGraphikContainer.Yru,derGraphikContainer.Xlo,derGraphikContainer.Ylo)
				dc.line (derGraphikContainer.Xlo,derGraphikContainer.Ylo,derGraphikContainer.Xru,derGraphikContainer.Ylo)
				dc.line (derGraphikContainer.Xru,derGraphikContainer.Ylo,derGraphikContainer.Xru,derGraphikContainer.Yru)
				pen.delete

			end
		end

end 
